From 84a8ec44b486d9ff78ae3b275896ed6bcd4922d2 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Wed, 19 Jun 2019 11:09:44 +0200
Subject: [PATCH] =?UTF-8?q?misc:=20update=20French=20translation=20to=20us?=
 =?UTF-8?q?e=20"r=C3=A9initialiser",=20no=20dash=20(#34116)?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 .../locale/fr/LC_MESSAGES/django.po           | 22 +++++++++----------
 .../manager/locale/fr/LC_MESSAGES/django.po   |  6 ++---
 2 files changed, 14 insertions(+), 14 deletions(-)

diff --git a/src/authentic2/locale/fr/LC_MESSAGES/django.po b/src/authentic2/locale/fr/LC_MESSAGES/django.po
index 1deec6f6..f2780045 100644
--- a/src/authentic2/locale/fr/LC_MESSAGES/django.po
+++ b/src/authentic2/locale/fr/LC_MESSAGES/django.po
@@ -8,7 +8,7 @@ msgstr ""
 "Project-Id-Version: Authentic\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2019-06-07 13:21+0200\n"
-"PO-Revision-Date: 2019-06-07 14:56+0200\n"
+"PO-Revision-Date: 2019-06-19 11:09+0200\n"
 "Last-Translator: Mikaël Ates <mates@entrouvert.com>\n"
 "Language-Team: None\n"
 "Language: fr\n"
@@ -804,7 +804,7 @@ msgstr "Nom"
 #: src/authentic2/templates/authentic2/api_user_create_registration_email_body.txt:8
 msgid "Please click on the following link to set your password:"
 msgstr ""
-"Veuillez cliquer sur le lien suivant pour ré-initialiser votre mot de passe"
+"Veuillez cliquer sur le lien suivant pour initialiser votre mot de passe"
 
 #: src/authentic2/templates/authentic2/api_user_create_registration_email_subject.txt:1
 #, python-format
@@ -872,7 +872,7 @@ msgstr ""
 "\n"
 "Pour récupérer le mot de passe de ce compte veuillez utiliser le formulaire "
 "de\n"
-"ré-initialisation de mot de passe\n"
+"réinitialisation de mot de passe\n"
 "\n"
 "  %(password_reset_url)s\n"
 "\n"
@@ -954,7 +954,7 @@ msgstr "Mot de passe perdu ?"
 
 #: src/authentic2/templates/authentic2/login_password_form.html:24
 msgid "Reset it!"
-msgstr "Ré-initialisez le !"
+msgstr "Réinitialisez le !"
 
 #: src/authentic2/templates/authentic2/login_password_form.html:27
 msgid "Not a member?"
@@ -1289,7 +1289,7 @@ msgstr "Vous allez définir le mot de passe de votre compte."
 
 #: src/authentic2/templates/registration/password_reset_confirm.html:21
 msgid "Password reset failed"
-msgstr "Ré-initialistion du mot de passe échouée"
+msgstr "Erreur à la réinitialistion du mot de passe"
 
 #: src/authentic2/templates/registration/password_reset_email.html:2
 #, python-format
@@ -1297,18 +1297,18 @@ msgid ""
 "You requested reset of your password on %(hostname)s, to proceed please\n"
 "click on the following link"
 msgstr ""
-"Vous avez demandé la ré-initialisation de votre mot de passe sur\n"
-"%(hostname)s, veuillez cliquer sur le lien suivant :"
+"Vous avez demandé la réinitialisation de votre mot de passe sur\n"
+"%(hostname)s, veuillez cliquer sur le lien suivant :"
 
 #: src/authentic2/templates/registration/password_reset_form.html:5
 #: src/authentic2/templates/registration/password_reset_form.html:10
 msgid "Resetting password"
-msgstr "Ré-initialiser le mot de passe"
+msgstr "Réinitialiser le mot de passe"
 
 #: src/authentic2/templates/registration/password_reset_subject.txt:2
 #, python-format
 msgid "Password reset on %(hostname)s"
-msgstr "Ré-initialiser le mot de passe sur %(hostname)s"
+msgstr "Réinitialiser le mot de passe sur %(hostname)s"
 
 #: src/authentic2/templates/registration/registration_closed.html:5
 #: src/authentic2/templates/registration/registration_closed.html:9
@@ -1592,7 +1592,7 @@ msgid ""
 "containing instructions to reset your password"
 msgstr ""
 "Si votre adresse électronique est présente dans notre base, vous recevrez un "
-"courriel contenant les instructions pour ré-initialiser votre mot de passe."
+"courriel contenant les instructions pour réinitialiser votre mot de passe."
 
 #: src/authentic2/views.py:697
 msgid "User not found"
@@ -1601,7 +1601,7 @@ msgstr "Utilisateur introuvable"
 #: src/authentic2/views.py:701
 msgid "You reset password link is invalid or has expired"
 msgstr ""
-"Votre lien de ré-initialisation de mot de passe est invalide ou expiré."
+"Votre lien de réinitialisation de mot de passe est invalide ou expiré."
 
 #: src/authentic2/views.py:710
 msgid ""
diff --git a/src/authentic2/manager/locale/fr/LC_MESSAGES/django.po b/src/authentic2/manager/locale/fr/LC_MESSAGES/django.po
index 00c5c882..e1ef6138 100644
--- a/src/authentic2/manager/locale/fr/LC_MESSAGES/django.po
+++ b/src/authentic2/manager/locale/fr/LC_MESSAGES/django.po
@@ -8,7 +8,7 @@ msgstr ""
 "Project-Id-Version: authentic2\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2019-03-08 10:43+0100\n"
-"PO-Revision-Date: 2018-09-28 10:53+0200\n"
+"PO-Revision-Date: 2019-06-19 11:09+0200\n"
 "Last-Translator: Benjamin Dauvergne <bdauvergne@entrouvert.com>\n"
 "Language-Team: French <fr@li.org>\n"
 "Language: \n"
@@ -71,7 +71,7 @@ msgid ""
 "reset mail"
 msgstr ""
 "Vous devez choisir entre la génération d'un mot de passe, en définir un "
-"nouveau ou envoyer un courriel de ré-initialisation."
+"nouveau ou envoyer un courriel de réinitialisation."
 
 #: src/authentic2/manager/forms.py:265
 msgid "User does not have a mail, we cannot send the informations to him."
@@ -893,7 +893,7 @@ msgstr "Créer"
 
 #: src/authentic2/manager/user_views.py:191
 msgid "Reset password"
-msgstr "Ré-initialiser le mot de passe"
+msgstr "Réinitialiser le mot de passe"
 
 #: src/authentic2/manager/user_views.py:194
 msgid "Suspend"
-- 
2.20.1