From bc2df49eca5306dd5d2289be65e3d82851b083ab Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Mon, 24 Jun 2019 13:03:39 +0200
Subject: [PATCH] fonts: add Now Alt (#34260)

---
 README                                          |   7 +++++++
 static/fonts/NowAlt/nowalt-black-webfont.woff   | Bin 0 -> 24616 bytes
 static/fonts/NowAlt/nowalt-black-webfont.woff2  | Bin 0 -> 18424 bytes
 static/fonts/NowAlt/nowalt-bold-webfont.woff    | Bin 0 -> 24840 bytes
 static/fonts/NowAlt/nowalt-bold-webfont.woff2   | Bin 0 -> 18480 bytes
 static/fonts/NowAlt/nowalt-light-webfont.woff   | Bin 0 -> 24016 bytes
 static/fonts/NowAlt/nowalt-light-webfont.woff2  | Bin 0 -> 18008 bytes
 static/fonts/NowAlt/nowalt-medium-webfont.woff  | Bin 0 -> 24696 bytes
 static/fonts/NowAlt/nowalt-medium-webfont.woff2 | Bin 0 -> 18472 bytes
 static/fonts/NowAlt/nowalt-regular-webfont.woff | Bin 0 -> 23812 bytes
 .../fonts/NowAlt/nowalt-regular-webfont.woff2   | Bin 0 -> 18200 bytes
 static/fonts/NowAlt/nowalt-thin-webfont.woff    | Bin 0 -> 22612 bytes
 static/fonts/NowAlt/nowalt-thin-webfont.woff2   | Bin 0 -> 17376 bytes
 static/includes/_font-nowalt.scss               |  16 ++++++++++++++++
 14 files changed, 23 insertions(+)
 create mode 100644 static/fonts/NowAlt/nowalt-black-webfont.woff
 create mode 100644 static/fonts/NowAlt/nowalt-black-webfont.woff2
 create mode 100644 static/fonts/NowAlt/nowalt-bold-webfont.woff
 create mode 100644 static/fonts/NowAlt/nowalt-bold-webfont.woff2
 create mode 100644 static/fonts/NowAlt/nowalt-light-webfont.woff
 create mode 100644 static/fonts/NowAlt/nowalt-light-webfont.woff2
 create mode 100644 static/fonts/NowAlt/nowalt-medium-webfont.woff
 create mode 100644 static/fonts/NowAlt/nowalt-medium-webfont.woff2
 create mode 100644 static/fonts/NowAlt/nowalt-regular-webfont.woff
 create mode 100644 static/fonts/NowAlt/nowalt-regular-webfont.woff2
 create mode 100644 static/fonts/NowAlt/nowalt-thin-webfont.woff
 create mode 100644 static/fonts/NowAlt/nowalt-thin-webfont.woff2
 create mode 100644 static/includes/_font-nowalt.scss

diff --git a/README b/README
index 94d022d5..f99b293d 100644
--- a/README
+++ b/README
@@ -164,6 +164,13 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/poppins
 
+* Now Alt
+  # Copyright (c) 2015, Alfredo Marco Pradil
+  # (<http://behance.net/pradil | ammpradil@gmail.com>),
+  # with Reserved Font Name Now Alt.
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1
+
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/NowAlt/nowalt-black-webfont.woff b/static/fonts/NowAlt/nowalt-black-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..1ec472a20cba3b2cd098912ff894b120211017a2
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-black-webfont.woff2 b/static/fonts/NowAlt/nowalt-black-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2ade12c34c15184c0d79bfad316ffe9cead2625a
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-bold-webfont.woff b/static/fonts/NowAlt/nowalt-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..921fbf7e00d9582c8afbe3f75bba249f58e646ea
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-bold-webfont.woff2 b/static/fonts/NowAlt/nowalt-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..a33df31ba6ce9e62fb20ed423911cf9ff6b23bdf
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-light-webfont.woff b/static/fonts/NowAlt/nowalt-light-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..62848101eeed6917564595b9fcffccf7b9a549c7
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-light-webfont.woff2 b/static/fonts/NowAlt/nowalt-light-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d2bbdad1604698738de210cc28de0a4350e6c834
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-medium-webfont.woff b/static/fonts/NowAlt/nowalt-medium-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..38b76a2433a688d783e73c89b418ab5d671f41f6
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-medium-webfont.woff2 b/static/fonts/NowAlt/nowalt-medium-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..5557d9145451b94a6fd57d13713b4c5258c42741
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-regular-webfont.woff b/static/fonts/NowAlt/nowalt-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..450fb5b66b1fd81ad79761dc3fa01ab625639106
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-regular-webfont.woff2 b/static/fonts/NowAlt/nowalt-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..27d63c797dd19aa1daae5825ac4a45721bf4e53d
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-thin-webfont.woff b/static/fonts/NowAlt/nowalt-thin-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..894ea694b1f0de01da630ebe495f4fd494e55471
GIT binary patch
diff --git a/static/fonts/NowAlt/nowalt-thin-webfont.woff2 b/static/fonts/NowAlt/nowalt-thin-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..7fb71a74b7f84e0b64d7b855e036d7492cc9bd53
GIT binary patch
diff --git a/static/includes/_font-nowalt.scss b/static/includes/_font-nowalt.scss
new file mode 100644
index 00000000..0ffb4d69
--- /dev/null
+++ b/static/includes/_font-nowalt.scss
@@ -0,0 +1,16 @@
+@mixin nowalt-font($type, $weight) {
+	@font-face {
+		font-family: 'Now Alt';
+		src: url('/static/fonts/NowAlt/nowalt-#{$type}-webfont.woff2') format('woff2'),
+		     url('/static/fonts/NowAlt/nowalt-#{$type}-webfont.woff') format('woff');
+		font-weight: $weight;
+		font-style: normal;
+	}
+}
+
+@include nowalt-font('thin', 100);
+@include nowalt-font('light', 300);
+@include nowalt-font('regular', 400);
+@include nowalt-font('medium', 500);
+@include nowalt-font('bold', 700);
+@include nowalt-font('black', 900);
-- 
2.20.1